tema-15-sesiones/frontend/main/forms/professor_form.py
# - *- coding: utf- 8 - *-
from flask_wtf import FlaskForm #Importa funciones de formulario
from wtforms import PasswordField, SubmitField, StringField #Importa campos
from wtforms.fields.html5 import EmailField,DateField #Importa campos HTML
from wtforms import validators #Importa validaciones

class ProfessorForm(FlaskForm):

    #Definición de campo String
    firstname = StringField('Firstname',
    [
        #Definición de validaciones
        validators.Required(message = "Firstname is required"),
        validators.Length(min=5)
    ])

    lastname = StringField('Lastname',
    [
        validators.Required(message = "Lastname is required"),
        validators.Length(min=5)
    ])

    #Definición de campo de mail
    email = EmailField('E-mail',
    [
        validators.Required(message = "E-mail is require"),
        validators.Email( message ='Formad not valid'),
    ])

    #Definición de campo de contraseña
    password = PasswordField('Password', [
        validators.Required(),
         #El campo de contraseña debe coincidir con el de confirmuar
        validators.EqualTo('confirm', message='Passwords dont match')
    ])

    confirm = PasswordField('Repeat Password')

    fechaNac = DateField('Fecha Nacimiento',
        [
            validators.Required()
        ], format='%Y-%m-%d',)

    #Definición de campo submit
    submit = SubmitField("Send")

tema-15-sesiones/frontend/main/forms/project_form.py
# - *- coding: utf- 8 - *-
from flask_wtf import FlaskForm #Importa funciones de formulario
from wtforms import PasswordField, SubmitField, StringField, SelectField, HiddenField#Importa campos
from wtforms.fields.html5 import EmailField, DateTimeField #Importa campos HTML
from wtforms import validators #Importa validaciones

class ProjectForm(FlaskForm):

    #Definición de campo String
    name = StringField('Name',
    [
        #Definición de validaciones
        validators.Required(message = "Name is required")
    ])

    year = DateTimeField('Year', format='%Y')

    professorId = SelectField('Leader Professor', coerce=int)

    professorInscr1Id = SelectField('Professor 1', coerce=int)

    professorInscr2Id = SelectField('Professor 2', coerce=int)

    professorInscr3Id = SelectField('Professor 3', coerce=int)
    #Definición de campo submit
    submit = SubmitField("Send")

tema-15-sesiones/frontend/main/routes/main.py
from flask import Blueprint, redirect, url_for, current_app, request, make_response, flash
from ..forms.auth_forms import  LoginForm
from flask_login import login_required, login_user, logout_user, current_user, LoginManager
from . import professor
import requests, json
from .auth import User

#Crear Blueprint
main = Blueprint('main', __name__, url_prefix='/')

@main.route('/')
def index():
    #Redireccionar a función de vista
    return redirect(url_for('professor.index'))

@main.route('/login', methods= ['POST'])
def login():
    loginForm = LoginForm()
    if loginForm.validate_on_submit():
        #Enviar requests
        data = '{"email":"'+loginForm.email.data+'", "password":"'+loginForm.password.data+'"}'
        r = requests.post(
            current_app.config["API_URL"]+'/auth/login',
            headers={"content-type":"application/json"},
            data = data)
        #Si la request se realiza con éxito
        if r.status_code == 200:
            #Cargar valores del usuario de la respuesta
            user_data = json.loads(r.text)
            user = User(id = user_data.get("id"), email = user_data.get("email"),  role = user_data.get("role") )
            #Loguear objeto usuario
            login_user(user)
            #Crear una request de redirección
            req = make_response(redirect(url_for('professor.index')))
            #Setear cookie con el valor del token
            req.set_cookie('access_token', user_data.get("access_token"), httponly = True)
            #Realizar la request
            return req
        else:
            #Mostrar error de autenticación
            flash('Usuario o contraseña incorrecta','danger')
    return redirect(url_for('professor.index'))

@main.route('/logout')
def logout():
    #Crear una request de redirección
    req = make_response(redirect(url_for('professor.index')))
    #Vaciar cookie
    req.set_cookie('access_token', '', httponly = True)
    #Deloguear usuario
    logout_user()
    #Realizar request
    return req

tema-15-sesiones/frontend/main/routes/professor.py
from flask import Blueprint, render_template, redirect, url_for, current_app, request
from ..forms.auth_forms import  LoginForm
# Importar objeto Form
from ..forms.professor_form import ProfessorForm
from flask_login import login_required, LoginManager,current_user
# Importar librería request para realizar consulta y json para manejar la estructura de datos
import requests, json
from .auth import admin_required

#Crear Blueprint
professor = Blueprint('professor', __name__, url_prefix='/professor')

@professor.route('/')
def index():
    loginForm = LoginForm()
    data = {}
    data['page'] = 1

    #Crear headers
    headers = {
    'content-type': "application/json"
    }

    # Generar consulta GET al endpoint
    r = requests.get(
        current_app.config["API_URL"]+'/professors',
        headers=headers,
        data = json.dumps(data))
    #Convertir respuesta de JSON a  diccionario
    professors = json.loads(r.text)["professors"]
    #Mostrar template
    return render_template('professor_list.html', professors=professors, loginForm = loginForm )

@professor.route('/view/<int:id>')
@login_required
def view(id):
    # Generar consulta GET al endpoint
    #Obtener token
    auth = request.cookies['access_token']
    #Crear headers
    headers = {
    'content-type': "application/json",
    'authorization': "Bearer "+auth
    }
    r = requests.get(
        current_app.config["API_URL"]+'/professor/'+str(id),
        headers=headers)
    # Verificar código de respuesta
    if(r.status_code==404):
        # Si el recurso no existe redireccionar
        return redirect(url_for('professor.index'))
    #Convertir respuesta de JSON a  diccionario
    professor = json.loads(r.text)
    #Mostrar template
    return render_template('professor_view.html',professor=professor  )

@professor.route('/create', methods=["POST","GET"])
@login_required
@admin_required
def create():
    form = ProfessorForm() #Instanciar formulario
    if form.validate_on_submit(): #Si el formulario ha sido enviado y es validado correctamente
        data = {}
        data["firstname"] = form.firstname.data
        data["lastname"] = form.lastname.data
        data["email"] = form.email.data
        data["password"] = form.password.data
        data["fechaNac"] = form.fechaNac.data.strftime("%Y-%m-%d")
        #Obtener token
        auth = request.cookies['access_token']
        #Crear headers
        headers = {
        'content-type': "application/json",
        'authorization': "Bearer "+auth
        }
        r = requests.post(
            current_app.config["API_URL"]+'/professors',
            headers = headers,
            data = json.dumps(data))
        return redirect(url_for('professor.index')) #Redirecciona a lista
    return render_template('professor_form.html', form = form) #Muestra el formulario

tema-15-sesiones/frontend/main/routes/project.py
from flask import Blueprint, render_template, current_app, redirect, url_for, current_app,  request
from ..forms.auth_forms import  LoginForm
# Importar objeto Form
from ..forms.project_form import ProjectForm
# Importar librería request para realizar consulta y json para manejar la estructura de datos
import requests, json
from flask import make_response
from flask_login import login_required, LoginManager, current_user
from .auth import admin_required


project = Blueprint('project', __name__, url_prefix='/project')

@project.route('/')
@login_required
def index():
    data = {}
    data['page'] = 1
    #Obtener token
    auth = request.cookies['access_token']
    #Crear headers
    headers = {
    'content-type': "application/json",
    'authorization': "Bearer "+auth
    }
    #Obtener proyects
    r = requests.get(
        current_app.config["API_URL"]+'/projects',
        headers = headers,
        data = json.dumps(data))
    #Cargar proyectos
    projects = json.loads(r.text)["projects"]
    #Mostrar template
    return render_template('project_list.html', projects=projects)

@project.route('/view/<int:id>')
@login_required
def view(id):
    #Obtener token
    auth = request.cookies['access_token']
    #Crear headers
    headers = {
    'content-type': "application/json",
    'authorization': "Bearer "+auth
    }
    r = requests.get(
        current_app.config["API_URL"]+'/project/'+str(id),
        headers=headers)
    if(r.status_code==404):
        return redirect(url_for('project.index'))
    project = json.loads(r.text)
    #Mostrar template
    return render_template('project_view.html', project=project)

@project.route('/create', methods=["POST","GET"])
@login_required
@admin_required
def create():
    #Instanciar formulario
    form = ProjectForm()
    # Obtener profesores
    data = {}
    data['page'] = 1
    #Obtener token
    auth = request.cookies['access_token']
    #Crear headers
    headers = {
    'content-type': "application/json",
    'authorization': "Bearer "+auth
    }
    r = requests.get(
            current_app.config["API_URL"]+'/professors',
            headers=headers,
            data = json.dumps(data))
    professors = [(item['id'], item['lastname']+" "+item['firstname']) for item in json.loads(r.text)["professors"]]
    inscriptions_p = [(item['id'], item['lastname']+" "+item['firstname']) for item in json.loads(r.text)["professors"]]

    # Cargar profesores en campo de formulario
    form.professorId.choices = professors
    inscriptions_p.insert(0, (0, ""))
    form.professorInscr1Id.choices = inscriptions_p
    form.professorInscr2Id.choices = inscriptions_p
    form.professorInscr3Id.choices = inscriptions_p
    if form.validate_on_submit(): #Si el formulario ha sido enviado y es validado correctamente
        # Cargar datos del formulario
        data = {}
        data["name"] = form.name.data
        data["year"] = form.year.data.year
        data["professorId"] = form.professorId.data
        inscriptions = []
        if form.professorInscr1Id.data != 0:
            inscriptions.append({"professorId":form.professorInscr1Id.data})
        if form.professorInscr2Id.data != 0:
            inscriptions.append({"professorId":form.professorInscr2Id.data})
        if form.professorInscr3Id.data != 0:
            inscriptions.append({"professorId":form.professorInscr3Id.data})
        data["inscriptions"] = inscriptions
        # Crear solicitud POST
        r = requests.post(
            current_app.config["API_URL"]+'/projects',
            headers = headers,
            data = json.dumps(data))
        if(r.status_code==201):
            return redirect(url_for('project.index')) #Redirecciona a lista
    return render_template('project_form.html', form = form) #Muestra el formulario

tema-15-sesiones/frontend/main/templates/main.html
{% from 'macros/form.html' import show_field_login, show_submit %}

<!DOCTYPE html>
<html lang="es">
	<head>
		<title>{{title}}</title>
		<meta charset="utf-8">
	<!--Colocar el viewport -->
	<meta name="viewport" content="width=device-width, initial-scale=1">
	 {% block head %}
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css" integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk" crossorigin="anonymous">
  {% endblock %}
  	</head>
	<body>

  {% block menu %}
  <!-- Barra de navegacion -->
  <nav class="navbar fixed-top navbar-expand-md navbar-dark bg-dark">
    <a class="navbar-brand" href="#">Projects</a>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item active">
          <a class="nav-link" href="{{url_for('main.index')}}">Home <span class="sr-only">(actual)</span></a>
        </li>
        <li class="nav-item">
          <a class="nav-link" href="{{url_for('professor.index')}}">Professor</a>
        </li>
				{% if current_user.is_authenticated %}
				<li class="nav-item">
          <a class="nav-link" href="{{url_for('project.index')}}">Projects</a>
        </li>
				{% endif %}
				<li class="nav-item" style="margin-left:450px;color:white">
				{% if current_user.is_authenticated %}
					<span style="margin-right:10px">Hola {{current_user.email}}</span><a href="{{ url_for('main.logout') }}" class="btn btn-secondary">Logout</a>
				{% else %}
					<form method="POST" action="{{ url_for('main.login') }}" >
						<input type="hidden" name="csrf_token" value="{{ csrf_token() }}"/>
						<div class="form-row">
							<div class="form-group col-md-5">
									{{ show_field_login(loginForm.email, class='form-control' )}}
							</div>
							<div class="form-group col-md-5">
									{{ show_field_login(loginForm.password , class='form-control')}}
							</div>
							<div class="form-group col-md-2" >
								{{ show_submit(loginForm.submit , class='btn btn-success')}}
							</div>
						</div>
					</form>
				{% endif %}
				</li>

        </ul>
      </div>
  </nav>
  {% endblock %}
  <br/><br/><br/>
		<div class="container-fluid">
 <div class="container">
	<div class="row">
		<div class="col-md-12">
		 {% with messages = get_flashed_messages(with_categories=true) %}
			 {% if messages %}
				 {% for category, message in messages %}
					 <div class="alert alert-{{category}} alert-dismissible fade show" role="alert">
						 {{ message }}
						 <button type="button" class="close" data-dismiss="alert" aria-label="Close">
							 <span aria-hidden="true">&times;</span>
						 </button>
					 </div>
				 {% endfor %}
				{% endif %}
		 {% endwith %}
	 </div>
 </div>
</div>


  {% block content %}
  {% endblock %}
  </div>

	 {% block scripts %}
	<!-- Incluir CDN Jquery-->
	<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<!-- Incluir CDN Popper-->
	<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
	<!-- Incluir CDN Js de Bootstrap-->
	<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>
   {% endblock %}
	</body>
</html>

tema-15-sesiones/frontend/main/templates/professor_form.html
<!-- Hereda de el template main -->
{% extends 'main.html'%}  {# Herencia #}
<!-- Importar macro -->
{% from 'macros/form.html' import show_field, show_submit %}

<!--Hereda el bloque de cabecera manteniendo su contenido con la función super() y agregando el link a la hoja de estilo al final del mismo -->
{% block head %}
    {{ super() }} {# Heredar el contenido del bloque bloque #}
    <link rel="stylesheet" href="{{url_for('static', filename='css/style.css')}}"> {# Nuevo contenido del bloque #}
{% endblock %}

<!-- Comienza el bloque de contenido y define su contenido -->
{% block content %}

<div class="container">
  <div class="row">
    <div class="col-md-12">
	    <form method="POST" action="{{ url_for('professor.create') }}" >
	      <input type="hidden" name="csrf_token" value="{{ csrf_token() }}"/>
	     	<div class="form-row">
	    		<div class="form-group col-md-4">
	      			{{ show_field(form.firstname, class='form-control' )}}
	    		</div>
	    		<div class="form-group col-md-4">
	      			{{ show_field(form.lastname , class='form-control')}}
	    		</div>
          <div class="form-group col-md-4">
              {{ show_field(form.fechaNac , class='form-control')}}
          </div>
	  		</div>
	  		<div class="form-row">
	    		<div class="form-group col-md-4">
	      			{{ show_field(form.email , class='form-control')}}
	      	</div>
          <div class="form-group col-md-4">
            {{ show_field(form.password , class='form-control')}}
          </div>
          <div class="form-group col-md-4">
            {{ show_field(form.confirm , class='form-control')}}
          </div>
	  		</div>
	  	  <!--Llama a macro especial para mostrar el campo de submit -->
	 			{{ show_submit(form.submit , class='btn btn-success')}}
	  	</form>
  	</div>
  </div>
</div>
{% endblock%}

tema-15-sesiones/frontend/main/templates/professor_list.html
<!-- Hereda de el template main -->
{% extends 'main.html'%}  {# Herencia #}
<!--Hereda el bloque de cabecera manteniendo su contenido con la función super() y agregando el link a la hoja de estilo al final del mismo -->
{% block head %}
    {{ super() }} {# Heredar el contenido del bloque bloque #}
    <link rel="stylesheet" href="{{url_for('static', filename='css/style.css')}}"> {# Nuevo contenido del bloque #}
{% endblock %}
<!-- Comienza el bloque de contenido y define su contenido -->
{% block content %}
		<div class="row">
				<div class="col-md-12 ">
					<h4>Professor List
            {% if current_user.is_authenticated and current_user.role == "admin" %}
            <a type="button" href="{{url_for('professor.create')}}" class="btn btn-success">Create</a>
            {% endif %}
          </h4>
				</div>
		  </div>
		 	<div class="row">
				<!--Columna -->
				<div class="col-md-12 ">
          <table class="table table-bordered table-dark table-striped">
          	<tr>
							<th>Firstname</th>
              <th>Lastname</th>
              <th>Email</th>
              {% if current_user.is_authenticated%}
              <th></th>
              {% endif %}
            </tr>
            {% for professor in professors %}
              <tr>
                <td>{{professor.firstname}}</td>
                <td>{{professor.lastname}}</td>
                <td>{{professor.email}}</td>
                {% if current_user.is_authenticated%}
                <td>
                  <a type="button" href="{{url_for('professor.view',id=professor.id)}}" class="btn btn-success">View</a>
                </td>
                {% endif %}

              </tr>
           {% endfor %}
					</table>
				</div>
		</div><!--Fin de la fila -->
  </div>
{% endblock %}

tema-15-sesiones/frontend/main/templates/professor_view.html
<!-- Hereda de el template main -->
{% extends 'main.html'%}  {# Herencia #}
<!-- Importar macro -->
{% import 'macros/professor.html' as macro %}
<!-- Comienza el bloque de contenido y define su contenido -->
{% block content %}
		<div class="row">
				<div class="col-md-12 ">
					<h2>Professor View <a type="button" href="{{url_for('project.create')}}" class="btn btn-success">Create Project</a></h2>
				</div>
		  </div>
		 	<div class="row">
				<!--Columna -->
				<div class="col-md-12 ">
					{{ macro.show_card_professor(professor) }}
				</div>
		</div><!--Fin de la fila -->
  </div>
	{% endblock %}

tema-15-sesiones/frontend/main/templates/project_form.html
<!-- Hereda de el template main -->
{% extends 'main.html'%}  {# Herencia #}
<!-- Importar macro -->
{% from 'macros/form.html' import show_field, show_submit %}
<!--Hereda el bloque de cabecera manteniendo su contenido con la función super() y agregando el link a la hoja de estilo al final del mismo -->
{% block head %}
    {{ super() }} {# Heredar el contenido del bloque bloque #}
    <link rel="stylesheet" href="{{url_for('static', filename='css/style.css')}}"> {# Nuevo contenido del bloque #}
{% endblock %}
<!-- Comienza el bloque de contenido y define su contenido -->
{% block content %}
<div class="container">
  <div class="row">
    <div class="col-md-12">
	    <form method="POST" action="{{ url_for('project.create') }}" >
	      <input type="hidden" name="csrf_token" value="{{ csrf_token() }}"/>
	     	<div class="form-row">
	    		<div class="form-group col-md-4">
	      			{{ show_field(form.name, class='form-control' )}}
	    		</div>
	    		<div class="form-group col-md-4">
	      			{{ show_field(form.year , class='form-control')}}
	    		</div>
          <div class="form-group col-md-4">
	      			{{ show_field(form.professorId , class='form-control')}}
	    		</div>
	  		</div>
        <div class="form-row">
        <div class="form-group col-md-4">
            {{ show_field(form.professorInscr1Id, class='form-control' )}}
        </div>
        <div class="form-group col-md-4">
            {{ show_field(form.professorInscr2Id , class='form-control')}}
        </div>
         <div class="form-group col-md-4">
            {{ show_field(form.professorInscr3Id , class='form-control')}}
        </div>
      </div>
	  		  <!--Llama a macro especial para mostrar el campo de submit -->
	 			{{ show_submit(form.submit , class='btn btn-success')}}
	  	</form>
  	</div>
  </div>
</div>
{% endblock%}

tema-15-sesiones/frontend/main/templates/project_list.html
<!-- Hereda de el template main -->
{% extends 'main.html'%}  {# Herencia #}
<!-- Importar macro -->
{% import 'macros/project.html' as macro %}

<!--Hereda el bloque de cabecera manteniendo su contenido con la función super() y agregando el link a la hoja de estilo al final del mismo -->
{% block head %}
    {{ super() }} {# Heredar el contenido del bloque bloque #}
    <link rel="stylesheet" href="{{url_for('static', filename='css/style.css')}}"> {# Nuevo contenido del bloque #}
{% endblock %}

<!-- Comienza el bloque de contenido y define su contenido -->
{% block content %}
<div class="row">
    <div class="col-md-12 ">
      <h4>Project List
      {% if current_user.is_authenticated and current_user.role == "admin" %}
        <a type="button" href="{{url_for('project.create')}}" class="btn btn-success">Create</a>
        {% endif %}
      </h4>
    </div>
  </div>
    <div class="row">
        <div class="col-md-12">
          <table class="table table-bordered table-dark">
						<tr>
							<th>#</th>
              <th>Name</th>
              <th>Year</th>
              <th>Professor</th>
              <th></th>
						</tr>
						{% for project in projects %}
						    {{ macro.show_project(project) }}
						{% endfor %}
					</table>
				</div>
		</div><!--Fin de la fila -->

{% endblock %}

tema-15-sesiones/frontend/main/templates/project_view.html
<!-- Hereda de el template main -->
{% extends 'main.html'%}  {# Herencia #}
<!-- Importar macro -->
{% import 'macros/project.html' as macro %}
<!-- Comienza el bloque de contenido y define su contenido -->
{% block content %}
		<div class="row">
				<div class="col-md-12 ">
					<h2>Project View</h2>
				</div>
		  </div>
		 	<div class="row">
				<!--Columna -->
				<div class="col-md-12 ">
					{{ macro.show_card_project(project) }}
				</div>
		</div><!--Fin de la fila -->
  </div>
	{% endblock %}